## GtkGesture

GtkGesture — Base class for gestures

## Functions

GdkDevice * | gtk_gesture_get_device ()
GdkWindow * | gtk_gesture_get_window ()
void | gtk_gesture_set_window ()
gboolean | gtk_gesture_is_active ()
gboolean | gtk_gesture_is_recognized ()
GtkEventSequenceState | gtk_gesture_get_sequence_state ()
gboolean | gtk_gesture_set_sequence_state ()
gboolean | gtk_gesture_set_state ()
GList * | gtk_gesture_get_sequences ()
gboolean | gtk_gesture_handles_sequence ()
GdkEventSequence * | gtk_gesture_get_last_updated_sequence ()
const GdkEvent * | gtk_gesture_get_last_event ()
gboolean | gtk_gesture_get_point ()
gboolean | gtk_gesture_get_bounding_box ()
gboolean | gtk_gesture_get_bounding_box_center ()
void | gtk_gesture_group ()
void | gtk_gesture_ungroup ()
GList * | gtk_gesture_get_group ()
gboolean | gtk_gesture_is_grouped_with ()

## Properties

guint | n-points | Read / Write / Construct Only
GdkWindow * | window | Read / Write

## Signals

void | begin | Run Last
void | cancel | Run Last
void | end | Run Last
void | sequence-state-changed | Run Last
void | update | Run Last

## Types and Values

| GtkGesture
enum | GtkEventSequenceState

## Object Hierarchy

        GObject
        ╰── GtkEventController
            ╰── GtkGesture
                ├── GtkGestureSingle
                ├── GtkGestureRotate
                ╰── GtkGestureZoom

## Includes

    #include <gtk/gtk.h>

## Description

GtkGesture is the base object for gesture recognition, although this object is quite generalized to serve as a base for multi-touch gestures, it is suitable to implement single-touch and pointer-based gestures (using the special `NULL` GdkEventSequence value for these).

The number of touches that a GtkGesture need to be recognized is controlled by the “n-points” property, if a gesture is keeping track of less or more than that number of sequences, it won't check wether the gesture is recognized.

As soon as the gesture has the expected number of touches, the gesture will run the “check” signal regularly on input events until the gesture is recognized, the criteria to consider a gesture as "recognized" is left to GtkGesture subclasses.

A recognized gesture will then emit the following signals:

- “begin” when the gesture is recognized.

- A number of “update”, whenever an input event is processed.

- “end” when the gesture is no longer recognized.

#### Event propagation

In order to receive events, a gesture needs to either set a propagation phase through `gtk_event_controller_set_propagation_phase()`, or feed those manually through `gtk_event_controller_handle_event()`.

In the capture phase, events are propagated from the toplevel down to the target widget, and gestures that are attached to containers above the widget get a chance to interact with the event before it reaches the target.

After the capture phase, GTK+ emits the traditional “button-press”, “button-release”, “touch-event”, etc signals. Gestures with the `GTK_PHASE_TARGET` phase are fed events from the default “event” handlers.

In the bubble phase, events are propagated up from the target widget to the toplevel, and gestures that are attached to containers above the widget get a chance to interact with events that have not been handled yet.

#### States of a sequence

Whenever input interaction happens, a single event may trigger a cascade of GtkGestures, both across the parents of the widget receiving the event and in parallel within an individual widget. It is a responsibility of the widgets using those gestures to set the state of touch sequences accordingly in order to enable cooperation of gestures around the GdkEventSequences triggering those.

Within a widget, gestures can be grouped through `gtk_gesture_group()`, grouped gestures synchronize the state of sequences, so calling `gtk_gesture_set_sequence_state()` on one will effectively propagate the state throughout the group.

By default, all sequences start out in the GTK_EVENT_SEQUENCE_NONE state, sequences in this state trigger the gesture event handler, but event propagation will continue unstopped by gestures.

If a sequence enters into the GTK_EVENT_SEQUENCE_DENIED state, the gesture group will effectively ignore the sequence, letting events go unstopped through the gesture, but the "slot" will still remain occupied while the touch is active.

If a sequence enters in the GTK_EVENT_SEQUENCE_CLAIMED state, the gesture group will grab all interaction on the sequence, by:

- Setting the same sequence to GTK_EVENT_SEQUENCE_DENIED on every other gesture group within the widget, and every gesture on parent widgets in the propagation chain.

- calling “cancel” on every gesture in widgets underneath in the propagation chain.

- Stopping event propagation after the gesture group handles the event.

Note: if a sequence is set early to GTK_EVENT_SEQUENCE_CLAIMED on GDK_TOUCH_BEGIN/GDK_BUTTON_PRESS (so those events are captured before reaching the event widget, this implies GTK_PHASE_CAPTURE), one similar event will emulated if the sequence changes to GTK_EVENT_SEQUENCE_DENIED. This way event coherence is preserved before event propagation is unstopped again.

Sequence states can't be changed freely, see `gtk_gesture_set_sequence_state()` to know about the possible lifetimes of a GdkEventSequence.

## Functions

### gtk_gesture_get_device ()

    GdkDevice *
    gtk_gesture_get_device (GtkGesture *gesture);

Returns the master GdkDevice that is currently operating on `gesture` , or `NULL` if the gesture is not being interacted.

#### Parameters

gesture | a GtkGesture |

#### Returns

a GdkDevice, or `NULL`.

[transfer none][allow-none]

Since 3.14

### gtk_gesture_get_window ()

    GdkWindow *
    gtk_gesture_get_window (GtkGesture *gesture);

Returns the user-defined window that receives the events handled by `gesture` . See `gtk_gesture_set_window()` for more information.

#### Parameters

gesture | a GtkGesture |

#### Returns

the user defined window, or `NULL` if none.

[transfer none][allow-none]

Since 3.14

### gtk_gesture_set_window ()

    void
    gtk_gesture_set_window (GtkGesture *gesture,
                            GdkWindow *window);

Sets a specific window to receive events about, so `gesture` will effectively handle only events targeting `window` , or a child of it. `window` must pertain to `gtk_event_controller_get_widget()`.

#### Parameters

gesture | a GtkGesture |
window | a GdkWindow, or `NULL`. | [allow-none]

Since 3.14

### gtk_gesture_is_active ()

    gboolean
    gtk_gesture_is_active (GtkGesture *gesture);

Returns `TRUE` if the gesture is currently active. A gesture is active meanwhile there are touch sequences interacting with it.

#### Parameters

gesture | a GtkGesture |

#### Returns

`TRUE` if gesture is active

Since 3.14

### gtk_gesture_is_recognized ()

    gboolean
    gtk_gesture_is_recognized (GtkGesture *gesture);

Returns `TRUE` if the gesture is currently recognized. A gesture is recognized if there are as many interacting touch sequences as required by `gesture` , and “check” returned `TRUE` for the sequences being currently interpreted.

#### Parameters

gesture | a GtkGesture |

#### Returns

`TRUE` if gesture is recognized

Since 3.14

### gtk_gesture_get_sequence_state ()

    GtkEventSequenceState
    gtk_gesture_get_sequence_state (GtkGesture *gesture,
                                    GdkEventSequence *sequence);

Returns the `sequence` state, as seen by `gesture` .

#### Parameters

gesture | a GtkGesture |
sequence | a GdkEventSequence |

#### Returns

The sequence state in `gesture`

Since 3.14

### gtk_gesture_set_sequence_state ()

    gboolean
    gtk_gesture_set_sequence_state (GtkGesture *gesture,
                                    GdkEventSequence *sequence,
                                    GtkEventSequenceState state);

Sets the state of `sequence` in `gesture` . Sequences start in state GTK_EVENT_SEQUENCE_NONE, and whenever they change state, they can never go back to that state. Likewise, sequences in state GTK_EVENT_SEQUENCE_DENIED cannot turn back to a not denied state. With these rules, the lifetime of an event sequence is constrained to the next four:

- None

- None → Denied

- None → Claimed

- None → Claimed → Denied

Note: Due to event handling ordering, it may be unsafe to set the state on another gesture within a “begin” signal handler, as the callback might be executed before the other gesture knows about the sequence. A safe way to perform this could be:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17

    static void
    first_gesture_begin_cb (GtkGesture       *first_gesture,
                            GdkEventSequence *sequence,
                            gpointer          user_data)
    {
      gtk_gesture_set_sequence_state (first_gesture, sequence, GTK_EVENT_SEQUENCE_ACCEPTED);
      gtk_gesture_set_sequence_state (second_gesture, sequence, GTK_EVENT_SEQUENCE_DENIED);
    }

    static void
    second_gesture_begin_cb (GtkGesture       *second_gesture,
                             GdkEventSequence *sequence,
                             gpointer          user_data)
    {
      if (gtk_gesture_get_sequence_state (first_gesture, sequence) == GTK_EVENT_SEQUENCE_ACCEPTED)
        gtk_gesture_set_sequence_state (second_gesture, sequence, GTK_EVENT_SEQUENCE_DENIED);
    }

If both gestures are in the same group, just set the state on the gesture emitting the event, the sequence will be already be initialized to the group's global state when the second gesture processes the event.

#### Parameters

gesture | a GtkGesture |
sequence | a GdkEventSequence |
state | the sequence state |

#### Returns

`TRUE` if `sequence` is handled by `gesture` , and the state is changed successfully

Since 3.14

### gtk_gesture_set_state ()

    gboolean
    gtk_gesture_set_state (GtkGesture *gesture,
                           GtkEventSequenceState state);

Sets the state of all sequences that `gesture` is currently interacting with. See `gtk_gesture_set_sequence_state()` for more details on sequence states.

#### Parameters

gesture | a GtkGesture |
state | the sequence state |

#### Returns

`TRUE` if the state of at least one sequence was changed successfully

Since 3.14

### gtk_gesture_get_sequences ()

    GList *
    gtk_gesture_get_sequences (GtkGesture *gesture);

Returns the list of GdkEventSequences currently being interpreted by `gesture` .

#### Parameters

gesture | a GtkGesture |

#### Returns

A list of GdkEventSequences, the list elements are owned by GTK+ and must not be freed or modified, the list itself must be deleted through `g_list_free()`.

[transfer container][element-type GdkEventSequence]

Since 3.14

### gtk_gesture_handles_sequence ()

    gboolean
    gtk_gesture_handles_sequence (GtkGesture *gesture,
                                  GdkEventSequence *sequence);

Returns `TRUE` if `gesture` is currently handling events corresponding to `sequence` .

#### Parameters

gesture | a GtkGesture |
sequence | a GdkEventSequence |

#### Returns

`TRUE` if `gesture` is handling `sequence`

Since 3.14

### gtk_gesture_get_last_updated_sequence ()

    GdkEventSequence *
    gtk_gesture_get_last_updated_sequence (GtkGesture *gesture);

Returns the GdkEventSequence that was last updated on `gesture` .

#### Parameters

gesture | a GtkGesture |

#### Returns

The last updated sequence

Since 3.14

### gtk_gesture_get_last_event ()

    const GdkEvent *
    gtk_gesture_get_last_event (GtkGesture *gesture,
                                GdkEventSequence *sequence);

Returns the last event that was processed for `sequence` .

#### Parameters

gesture | a GtkGesture |
sequence | a GdkEventSequence |

#### Returns

The last event from `sequence` .

[transfer none]

### gtk_gesture_get_point ()

    gboolean
    gtk_gesture_get_point (GtkGesture *gesture,
                           GdkEventSequence *sequence,
                           gdouble *x,
                           gdouble *y);

If `sequence` is currently being interpreted by `gesture` , this function returns `TRUE` and fills in `x` and `y` with the last coordinates stored for that event sequence. The coordinates are always relative to the widget allocation.

#### Parameters

gesture | a GtkGesture |
sequence | a GdkEventSequence, or `NULL` for pointer events. | [allow-none]
x | return location for X axis of the sequence coordinates. | [out][allow-none]
y | return location for Y axis of the sequence coordinates. | [out][allow-none]

#### Returns

`TRUE` if `sequence` is currently interpreted

Since 3.14

### gtk_gesture_get_bounding_box ()

    gboolean
    gtk_gesture_get_bounding_box (GtkGesture *gesture,
                                  GdkRectangle *rect);

If there are touch sequences being currently handled by `gesture` , this function returns `TRUE` and fills in `rect` with the bounding box containing all active touches. Otherwise, `FALSE` will be returned.

#### Parameters

gesture | a GtkGesture |
rect | bounding box containing all active touches. | [out]

#### Returns

`TRUE` if there are active touches, `FALSE` otherwise

Since 3.14

### gtk_gesture_get_bounding_box_center ()

    gboolean
    gtk_gesture_get_bounding_box_center (GtkGesture *gesture,
                                         gdouble *x,
                                         gdouble *y);

If there are touch sequences being currently handled by `gesture` , this function returns `TRUE` and fills in `x` and `y` with the center of the bounding box containing all active touches. Otherwise, `FALSE` will be returned.

#### Parameters

gesture | a GtkGesture |
x | X coordinate for the bounding box center. | [out]
y | Y coordinate for the bounding box center. | [out]

#### Returns

`FALSE` if no active touches are present, `TRUE` otherwise

Since 3.14

### gtk_gesture_group ()

    void
    gtk_gesture_group (GtkGesture *group_gesture,
                       GtkGesture *gesture);

Adds `gesture` to the same group than `group_gesture` . Gestures are by default isolated in their own groups.

When gestures are grouped, the state of GdkEventSequences is kept in sync for all of those, so calling `gtk_gesture_set_sequence_state()`, on one will transfer the same value to the others.

Groups also perform an "implicit grabbing" of sequences, if a GdkEventSequence state is set to GTK_EVENT_SEQUENCE_CLAIMED on one group, every other gesture group attached to the same GtkWidget will switch the state for that sequence to GTK_EVENT_SEQUENCE_DENIED.

#### Parameters

gesture | a GtkGesture |
group_gesture | GtkGesture to group `gesture` with |

Since 3.14

### gtk_gesture_ungroup ()

    void
    gtk_gesture_ungroup (GtkGesture *gesture);

Separates `gesture` into an isolated group.

#### Parameters

gesture | a GtkGesture |

Since 3.14

### gtk_gesture_get_group ()

    GList *
    gtk_gesture_get_group (GtkGesture *gesture);

Returns all gestures in the group of `gesture`

#### Parameters

gesture | a GtkGesture |

#### Returns

The list of GtkGestures, free with `g_list_free()`.

[element-type GtkGesture][transfer container]

Since 3.14

### gtk_gesture_is_grouped_with ()

    gboolean
    gtk_gesture_is_grouped_with (GtkGesture *gesture,
                                 GtkGesture *other);

Returns `TRUE` if both gestures pertain to the same group.

#### Parameters

gesture | a GtkGesture |
other | another GtkGesture |

#### Returns

whether the gestures are grouped

Since 3.14

## Types and Values

### GtkGesture

    typedef struct _GtkGesture GtkGesture;

### enum GtkEventSequenceState

Describes the state of a GdkEventSequence in a GtkGesture.

#### Members

GTK_EVENT_SEQUENCE_NONE | The sequence is handled, but not grabbed. |
GTK_EVENT_SEQUENCE_CLAIMED | The sequence is handled and grabbed. |
GTK_EVENT_SEQUENCE_DENIED | The sequence is denied. |

Since 3.14

## Property Details

### The `“n-points”` property

      “n-points”                 guint

The number of touch points that trigger recognition on this gesture,

Flags: Read / Write / Construct Only

Allowed values: >= 1

Default value: 1

Since 3.14

### The `“window”` property

      “window”                   GdkWindow *

If non-`NULL`, the gesture will only listen for events that happen on this GdkWindow, or a child of it.

Flags: Read / Write

Since 3.14

## Signal Details

### The `“begin”` signal

    void
    user_function (GtkGesture       *gesture,
                   GdkEventSequence *sequence,
                   gpointer          user_data)

This signal is emitted when the gesture is recognized. This means the number of touch sequences matches “n-points”, and the “check” handler(s) returned TRUE.

Note: These conditions may also happen when an extra touch (eg. a third touch on a 2-touches gesture) is lifted, in that situation `sequence` won't pertain to the current set of active touches, so don't rely on this being true.

#### Parameters

gesture | the object which received the signal |
sequence | the GdkEventSequence that made the gesture to be recognized |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 3.14

### The `“cancel”` signal

    void
    user_function (GtkGesture       *gesture,
                   GdkEventSequence *sequence,
                   gpointer          user_data)

This signal is emitted whenever a sequence is cancelled. This usually happens on active touches when `gtk_event_controller_reset()` is called on `gesture` (manually, due to grabs...), or the individual `sequence` was claimed by parent widgets' controllers (see `gtk_gesture_set_sequence_state()`).

`gesture` must forget everything about `sequence` as a reaction to this signal.

#### Parameters

gesture | the object which received the signal |
sequence | the GdkEventSequence that was cancelled |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 3.14

### The `“end”` signal

    void
    user_function (GtkGesture       *gesture,
                   GdkEventSequence *sequence,
                   gpointer          user_data)

This signal is emitted when `gesture` either stopped recognizing the event sequences as something to be handled (the “check” handler returned `FALSE`), or the number of touch sequences became higher or lower than “n-points”.

Note: `sequence` might not pertain to the group of sequences that were previously triggering recognition on `gesture` (ie. a just pressed touch sequence that exceeds “n-points”). This situation may be detected by checking through `gtk_gesture_handles_sequence()`.

#### Parameters

gesture | the object which received the signal |
sequence | the GdkEventSequence that made gesture recognition to finish |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 3.14

### The `“sequence-state-changed”` signal

    void
    user_function (GtkGesture           *gesture,
                   GdkEventSequence     *sequence,
                   GtkEventSequenceState state,
                   gpointer              user_data)

This signal is emitted whenever a sequence state changes. See `gtk_gesture_set_sequence_state()` to know more about the expectable sequence lifetimes.

#### Parameters

gesture | the object which received the signal |
sequence | the GdkEventSequence that was cancelled |
state | the new sequence state |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 3.14

### The `“update”` signal

    void
    user_function (GtkGesture       *gesture,
                   GdkEventSequence *sequence,
                   gpointer          user_data)

This signal is emitted whenever an event is handled while the gesture is recognized. `sequence` is guaranteed to pertain to the set of active touches.

#### Parameters

gesture | the object which received the signal |
sequence | the GdkEventSequence that was updated |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 3.14

## See Also

GtkEventController, GtkGestureSingle